diff --git a/fw/cache.c b/fw/cache.c
index 4c92c5c58..c798932b5 100644
--- a/fw/cache.c
+++ b/fw/cache.c
@@ -846,6 +846,9 @@ tfw_cache_send_304(TfwHttpReq *req, TfwCacheEntry *ce)
 
 		resp->mit.start_off = FRAME_HEADER_SIZE;
 
+		r = tfw_hpack_enc_tbl_size_expand(resp, &h_len);
+		if (unlikely(r))
+			goto err_setup;
 		r = tfw_h2_resp_status_write(resp, 304, TFW_H2_TRANS_EXPAND,
 					     true);
 		if (unlikely(r))
diff --git a/fw/hpack.c b/fw/hpack.c
index 60e9099dd..1dfe55ea6 100644
--- a/fw/hpack.c
+++ b/fw/hpack.c
@@ -3082,7 +3082,7 @@ tfw_hpack_rbuf_calc(TfwHPackETbl *__restrict tbl, unsigned short new_size,
 			return 0;
 		}
 
-		if (i >= HPACK_MAX_ENC_EVICTION)
+		if (i >= HPACK_MAX_ENC_EVICTION && del_list)
 			return -E2BIG;
 
 		f_len = HPACK_NODE_SIZE(first);
@@ -4002,15 +4002,70 @@ tfw_hpack_set_rbuf_size(TfwHPackETbl *__restrict tbl, unsigned short new_size)
 	T_DBG3("%s: tbl->rb_len=%hu, tbl->size=%hu, tbl->window=%hu,"
 	       " new_size=%hu\n", __func__, tbl->rb_len, tbl->size,
 	       tbl->window, new_size);
-
-	if (tbl->window > new_size) {
+	if (!tbl->window || tbl->window > new_size ||
+	    (!tbl->wnd_changed && tbl->window != new_size)) {
 		if (tbl->size > new_size)
 			tfw_hpack_rbuf_calc(tbl, new_size, NULL,
 					    (TfwHPackETblIter *)tbl);
 		WARN_ON_ONCE(tbl->rb_len > tbl->size);
 
 		tbl->window = new_size;
+		tbl->wnd_changed = 1;
 	}
 
 	spin_unlock(&tbl->lock);
 }
+
+#define __TFW_HPACK_ENC_TBL_SIZE_CHANGED_DECLARE_VARS(resp)		\
+	struct sk_buff __maybe_unused **skb_head = &resp->msg.skb_head;	\
+	TfwH2Ctx *ctx = tfw_h2_context(resp->req->conn);		\
+	TfwHPackETbl *tbl = &ctx->hpack.enc_tbl;			\
+	TfwHttpTransIter *mit = &resp->mit;				\
+	TfwStr s_vsize = {};						\
+	TfwHPackInt vsize;						\
+	int r = 0;
+
+int
+tfw_hpack_enc_tbl_size_expand(TfwHttpResp *__restrict resp,
+			      unsigned long *__restrict bytes_written)
+{
+	__TFW_HPACK_ENC_TBL_SIZE_CHANGED_DECLARE_VARS(resp);
+
+	if (unlikely(tbl->wnd_changed)) {
+		write_int(tbl->window, 0x1F, 0x20, &vsize);
+		s_vsize.data = vsize.buf;
+		s_vsize.len = vsize.sz;
+
+		r = tfw_http_msg_expand_data(&mit->iter, skb_head, &s_vsize,
+					     &mit->start_off);
+		if (likely(!r)) {
+			*bytes_written = vsize.sz;
+			tbl->wnd_changed = 0;
+		}
+	}
+
+	return r;
+}
+
+int
+tfw_hpack_enc_tbl_size_add(TfwHttpResp *__restrict resp, const char *stop,
+			   unsigned long *__restrict bytes_written)
+{
+	__TFW_HPACK_ENC_TBL_SIZE_CHANGED_DECLARE_VARS(resp);
+
+	if (unlikely(tbl->wnd_changed)) {
+		write_int(tbl->window, 0x1F, 0x20, &vsize);
+		s_vsize.data = vsize.buf;
+		s_vsize.len = vsize.sz;
+
+		r = tfw_h2_msg_rewrite_data(mit, &s_vsize, stop);
+		if (likely(!r)) {
+			*bytes_written = vsize.sz;
+			tbl->wnd_changed = 0;
+		}
+	}
+
+	return r;
+}
+
+#undef __TFW_HPACK_ENC_TBL_SIZE_CHANGED_DECLARE_VARS
\ No newline at end of file
diff --git a/fw/hpack.h b/fw/hpack.h
index 5cb81ec69..485ce0140 100644
--- a/fw/hpack.h
+++ b/fw/hpack.h
@@ -92,6 +92,7 @@ typedef struct {
 typedef struct {
 	TFW_HPACK_ETBL_COMMON;
 	unsigned short		window;
+	unsigned short		wnd_changed;
 	char			*rbuf;
 	TfwHPackNode		*root;
 	TfwPool			*pool;
@@ -279,6 +280,10 @@ int tfw_hpack_cache_decode_expand(TfwHPack *__restrict hp,
 				  unsigned char *__restrict src, unsigned long n,
 				  TfwDecodeCacheIter *__restrict cd_iter);
 void tfw_hpack_enc_release(TfwHPack *__restrict hp, unsigned long *flags);
+int tfw_hpack_enc_tbl_size_expand(TfwHttpResp *__restrict resp,
+				  unsigned long *__restrict bytes_written);
+int tfw_hpack_enc_tbl_size_add(TfwHttpResp *__restrict resp, const char *stop,
+			       unsigned long *__restrict bytes_written);
 
 static inline unsigned int
 tfw_hpack_int_size(unsigned long index, unsigned short max)
diff --git a/fw/http.c b/fw/http.c
index f22f2a38f..d56a3b706 100644
--- a/fw/http.c
+++ b/fw/http.c
@@ -582,6 +582,10 @@ tfw_h2_prep_resp(TfwHttpResp *resp, unsigned short status, TfwStr *msg,
 
 	/* Set HTTP/2 ':status' pseudo-header. */
 	mit->start_off = FRAME_HEADER_SIZE;
+	r = tfw_hpack_enc_tbl_size_expand(resp, &hdrs_len);
+	if (unlikely(r))
+		return r;
+
 	r = tfw_h2_resp_status_write(resp, status, TFW_H2_TRANS_EXPAND, false);
 	if (unlikely(r))
 		return r;
@@ -5360,11 +5364,13 @@ tfw_h2_resp_adjust_fwd(TfwHttpResp *resp)
 {
 	int r;
 	unsigned int stream_id;
+	unsigned long bytes_written = 0;
 	bool hdrs_end = false;
 	TfwHttpReq *req = resp->req;
 	TfwH2Ctx *ctx = tfw_h2_context(req->conn);
 	TfwHttpTransIter *mit = &resp->mit;
 	TfwStr codings = {.data = *this_cpu_ptr(&g_te_buf), .len = 0};
+	TfwStr *last = TFW_STR_LAST(&resp->crlf);
 	const TfwHdrMods *h_mods = tfw_vhost_get_hdr_mods(req->location,
 							  req->vhost,
 							  TFW_VHOST_HDRMOD_RESP);
@@ -5409,6 +5415,11 @@ tfw_h2_resp_adjust_fwd(TfwHttpResp *resp)
 
 	tfw_h2_msg_transform_setup(mit, resp->msg.skb_head, true);
 
+	r = tfw_hpack_enc_tbl_size_add(resp, last->data + last->len,
+				       &bytes_written);
+	if (unlikely(r))
+		goto clean;
+
 	r = tfw_h2_resp_next_hdr(resp, h_mods);
 	if (unlikely(r))
 		goto clean;
